/*********************************************************************
 *                  Flowcode CAL CAN File
 *
 * File: PIC_CAL_CAN.c
 *
 * (c) 2011 Matrix Multimedia Ltd.
 * http://www.matrixmultimedia.com
 *
 * Software License Agreement
 *
 * The software supplied herewith by Matrix Multimedia Ltd (the
 * Company) for its Flowcode graphical programming language is
 * intended and supplied to you, the Companys customer, for use
 * solely and exclusively on the Company's products. The software
 * is owned by the Company, and is protected under applicable
 * copyright laws. All rights are reserved. Any use in violation
 * of the foregoing restrictions may subject the user to criminal
 * sanctions under applicable laws, as well as to civil liability
 * for the breach of the terms and conditions of this licence.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Changelog:
 *
 *  date  | by | description
 * -------+----+-----------------------------------------------------
 * 241111 | BR | Created
 *
 *
 *
 */


//CAP Touch Functions
void FC_CAL_CAP_Touch_Init (void);
void FC_CAL_CAP_Touch_Reset (void);
void FC_CAL_CAP_Touch_Drain (void);
void FC_CAL_CAP_Touch_Charge (void);
void FC_CAL_CAP_Touch_Stop (void);


void FC_CAL_CAP_Touch_Init (void)
{
	ctmuconh = 0x00; 					//make sure CTMU is disabled
	ctmuconl = 0x90;
	ctmuicon = 0x01;              		//0.55uA, Nominal - No Adjustment
}


void FC_CAL_CAP_Touch_Reset (void)
{
	st_bit(ctmuconh, CTMUEN);
	cr_bit(ctmuconl, EDG1STAT);			//Set Edge status bits to zero
	cr_bit(ctmuconl, EDG2STAT);
}


void FC_CAL_CAP_Touch_Drain (void)
{
	st_bit(ctmuconh, IDISSEN);			//drain charge on the circuit
}


void FC_CAL_CAP_Touch_Charge (void)
{
	cr_bit(ctmuconh, IDISSEN);			//end drain
	st_bit(ctmuconl, EDG1STAT);			//Begin charging the circuit
}


void FC_CAL_CAP_Touch_Stop (void)
{
	cr_bit(ctmuconl, EDG1STAT); 		//Stop charging circuit
}
