/*********************************************************************
 *                  Flowcode CAL TypeDefs File
 *
 * File: PIC_CAL_TypeDefs.c
 *
 * (c) 2011 Matrix Multimedia Ltd.
 * http://www.matrixmultimedia.com
 *
 * Software License Agreement
 *
 * The software supplied herewith by Matrix Multimedia Ltd (the
 * Company) for its Flowcode graphical programming language is
 * intended and supplied to you, the Companys customer, for use
 * solely and exclusively on the Company's products. The software
 * is owned by the Company, and is protected under applicable
 * copyright laws. All rights are reserved. Any use in violation
 * of the foregoing restrictions may subject the user to criminal
 * sanctions under applicable laws, as well as to civil liability
 * for the breach of the terms and conditions of this licence.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Changelog:
 *
 *  date  | by | description
 * -------+----+-----------------------------------------------------
 * 010911 | BR | Created
 *
 *
 *
 */



typedef signed char    	MX_SINT8;
typedef signed short   	MX_SINT16;
typedef signed long    	MX_SINT32;
typedef unsigned char  	MX_UINT8;
typedef unsigned short 	MX_UINT16;
typedef unsigned long  	MX_UINT32;
typedef char       		MX_CHAR;
typedef MX_UINT16      	MX_UINT;   // Best integer value for the platform, at least 8 bit
typedef MX_SINT16      	MX_SINT;

#define MX_STRING 		char*		// String pointer


#ifdef _BOOSTC

	typedef bool        MX_BOOL;   // Or unsigned MX_UINT8, depending on platform

	#define MX_FLOAT 	float

#endif


#ifdef HI_TECH_C

	typedef bit     	MX_BOOL;   // Or unsigned MX_UINT8, depending on platform

	typedef double     	MX_FLOAT;  // In BoostC, needs '#define MX_FLOAT float'

#endif


typedef union
{
  MX_UINT32 AsLong;
  MX_UINT16 AsInt[2];
  MX_UINT8  AsByte[4];
} MX_Union32;

typedef union
{
  MX_UINT16 AsInt;
  MX_UINT8  AsByte[2];
} MX_Union16;




//Example Union Code
//MX_Union32 Test;
//Test.AsLong = 0xFFFFFFFF;
//Test.AsInt[0] = 0xFFFF;
//Test.AsByte[0] = 0xFF;

