/*********************************************************************
 *                    Flowcode USB Component Code
 *
 * File: pic_usb_buffer_mgt.h
 *
 * (c) 2009 Matrix Multimedia Ltd.
 * http://www.matrixmultimedia.com
 *
 * Software License Agreement
 *
 * The software supplied herewith by Matrix Multimedia Ltd (the
 * Company) for its Flowcode graphical programming language is
 * intended and supplied to you, the Companys customer, for use
 * solely and exclusively on the Company's products. The software
 * is owned by the Company, and is protected under applicable
 * copyright laws. All rights are reserved. Any use in violation
 * of the foregoing restrictions may subject the user to criminal
 * sanctions under applicable laws, as well as to civil liability
 * for the breach of the terms and conditions of this licence.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Changelog:
 *
 *  date  | by | description
 * -------+----+-----------------------------------------------------
 * 031008 | BR | Created
 * 190711 | BR | Confirmed current version
 ********************************************************************/

#ifndef __pic_usb_buffer_mgt_h
#define __pic_ubs_buffer_mgt_h

#include "pic_usb.h"

extern buffer_descriptor bd0out;
extern buffer_descriptor bd0in;
extern buffer_descriptor bd1out;
extern buffer_descriptor bd1in;
extern buffer_descriptor bd2out;
extern buffer_descriptor bd2in;
extern buffer_descriptor bd3out;
extern buffer_descriptor bd3in;

extern uns8 buffer_0_out[USB_EP0_OUT_SIZE];
extern uns8 buffer_0_in [USB_EP0_IN_SIZE];

#ifdef USB_EP1_IN_SIZE
	extern uns8 buffer_1_in [USB_EP1_IN_SIZE];
#endif
#ifdef USB_EP1_OUT_SIZE
	extern uns8 buffer_1_out [USB_EP1_OUT_SIZE];
#endif
#ifdef USB_EP2_IN_SIZE
	extern uns8 buffer_2_in [USB_EP2_IN_SIZE];
#endif
#ifdef USB_EP2_OUT_SIZE
	extern uns8 buffer_2_out [USB_EP2_OUT_SIZE];
#endif
#ifdef USB_EP3_IN_SIZE
	extern uns8 buffer_3_in [USB_EP3_IN_SIZE];
#endif
#ifdef USB_EP3_OUT_SIZE
	extern uns8 buffer_3_out [USB_EP3_OUT_SIZE];
#endif

extern buffer_descriptor * ep_in_bd_location[USB_HIGHEST_EP + 1];
extern buffer_descriptor * ep_out_bd_location[USB_HIGHEST_EP + 1];

extern uns8 * ep_in_buffer_location[USB_HIGHEST_EP + 1];

extern uns8 * ep_out_buffer_location[USB_HIGHEST_EP + 1];

extern uns16 ep_in_buffer_size[USB_HIGHEST_EP + 1];

extern uns16 ep_out_buffer_size[USB_HIGHEST_EP + 1];

#endif

