/*********************************************************************
 *           Flowcode Peripheral Slot Allocation Header File
 *
 * File: includes.c
 *
 * (c) 2011 Matrix Multimedia Ltd.
 * http://www.matrixmultimedia.com
 *
 * Software License Agreement
 *
 * The software supplied herewith by Matrix Multimedia Ltd (the
 * Company) for its Flowcode graphical programming language is
 * intended and supplied to you, the Companys customer, for use
 * solely and exclusively on the Company's products. The software
 * is owned by the Company, and is protected under applicable
 * copyright laws. All rights are reserved. Any use in violation
 * of the foregoing restrictions may subject the user to criminal
 * sanctions under applicable laws, as well as to civil liability
 * for the breach of the terms and conditions of this licence.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Changelog:
 *
 *  date  | by | description
 * -------+----+-----------------------------------------------------
 * 160911 | BR | Created
 * 011211 | BR | Converted to new dynamic defines mechanism
 ****************************************************************/


//Sniff to see if any ADC channels are being used
#ifdef	MX_ADC_REF
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_ADC.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_ADC.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_ADC.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_ADC.c"
  #endif
#endif


//Sniff to see if any CAN components are being used
#ifdef	MX_CAN_REF1
  #define CALFUNCTION(type, name, args) type CAL_APPEND(name, MX_CAN_NUM) args
  #define MX_CAN_NUM 1
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_CAN.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_CAN.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_CAN.c"
  #endif
  #ifdef FC_CAL_ARM
	#error "Internal CAN not supported on ARM AT91SAM7S devices"
  #endif
  #undef MX_CAN_NUM
#endif
#ifdef	MX_CAN_REF2
  #define MX_CAN_NUM 2
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_CAN.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_CAN.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_CAN.c"
  #endif
  #ifdef FC_CAL_ARM
	#error "Internal CAN not supported on ARM AT91SAM7S devices"
  #endif
  #undef MX_CAN_NUM
#endif
#ifdef CALFUNCTION
	#undef CALFUNCTION
#endif


//Sniff to see if any Cap Touch components are being used
#ifdef	MX_CAPTOUCH_REF
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_CAPTOUCH.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#error "Cap Touch not currently supported on 16-bit PIC devices"
  #endif
  #ifdef FC_CAL_AVR
	#error "Cap Touch not currently supported on AVR devices"
  #endif
  #ifdef FC_CAL_ARM
	#error "Cap Touch not currently supported on ARM AT91SAM7S devices"
  #endif
#endif


//Sniff to see if any EEPROM memory is being used
#ifdef	MX_EEPROM_REF
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_EEPROM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_EEPROM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_EEPROM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_EEPROM.c"
  #endif
#endif


//Sniff to see if any Flash memory is being used
#ifdef	MX_FLASH_REF
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_FLASH.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_FLASH.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_FLASH.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_FLASH.c"
  #endif
#endif


//Sniff to see if any I2C Channels are being used
#ifdef	MX_I2C_REF1
  #define CALFUNCTION(type, name, args) type CAL_APPEND(name, MX_I2C_NUM) args
  #define MX_I2C_NUM 1
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_I2C.c"
  #endif
  #undef MX_I2C_NUM
#endif
#ifdef	MX_I2C_REF2
  #define MX_I2C_NUM 2
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_I2C.c"
  #endif
  #undef MX_I2C_NUM
#endif
#ifdef	MX_I2C_REF3
  #define MX_I2C_NUM 3
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_I2C.c"
  #endif
  #undef MX_I2C_NUM
#endif
#ifdef	MX_I2C_REF4
  #define MX_I2C_NUM 4
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_I2C.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_I2C.c"
  #endif
  #undef MX_I2C_NUM
#endif
#ifdef CALFUNCTION
	#undef CALFUNCTION
#endif


//Sniff to see if any PWM channels are being used
#ifdef	MX_PWM_REF1
  #define CALFUNCTION(type, name, args) type CAL_APPEND(name, MX_PWM_NUM) args
  #define MX_PWM_NUM 1
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF2
  #define MX_PWM_NUM 2
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF3
  #define MX_PWM_NUM 3
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF4
  #define MX_PWM_NUM 4
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF5
  #define MX_PWM_NUM 5
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF6
  #define MX_PWM_NUM 6
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF7
  #define MX_PWM_NUM 7
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF8
  #define MX_PWM_NUM 8
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF9
  #define MX_PWM_NUM 9
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef	MX_PWM_REF10
  #define MX_PWM_NUM 10
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_PWM.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_PWM.c"
  #endif
  #undef MX_PWM_NUM
#endif
#ifdef CALFUNCTION
	#undef CALFUNCTION
#endif


//Sniff to see if any SPI channels are being used
#ifdef	MX_SPI_REF1
  #define CALFUNCTION(type, name, args) type CAL_APPEND(name, MX_SPI_NUM) args
  #define MX_SPI_NUM 1
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_SPI.c"
  #endif
  #undef MX_SPI_NUM
#endif
#ifdef	MX_SPI_REF2
  #define MX_SPI_NUM 2
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_SPI.c"
  #endif
  #undef MX_SPI_NUM
#endif
#ifdef	MX_SPI_REF3
  #define MX_SPI_NUM 3
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_SPI.c"
  #endif
  #undef MX_SPI_NUM
#endif
#ifdef	MX_SPI_REF4
  #define MX_SPI_NUM 4
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\PIC_CAL_SPI.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\PIC_CAL_SPI.c"
  #endif
  #undef MX_SPI_NUM
#endif
#ifdef CALFUNCTION
	#undef CALFUNCTION
#endif


//Sniff to see if any UARTS are being used
#ifdef	MX_UART_REF1
  #define CALFUNCTION(type, name, args) type CAL_APPEND(name, MX_UART_NUM) args
  #define MX_UART_NUM 1
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_UART.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_UART.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_UART.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_UART.c"
  #endif
  #undef MX_UART_NUM
#endif
#ifdef	MX_UART_REF2
  #define MX_UART_NUM 2
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_UART.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_UART.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_UART.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_UART.c"
  #endif
  #undef MX_UART_NUM
#endif
#ifdef	MX_UART_REF3
  #define MX_UART_NUM 3
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_UART.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_UART.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_UART.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_UART.c"
  #endif
  #undef MX_UART_NUM
#endif
#ifdef	MX_UART_REF4
  #define MX_UART_NUM 4
  #ifdef FC_CAL_PIC
	#include "PIC\PIC_CAL_UART.c"
  #endif
  #ifdef FC_CAL_PIC16BIT
	#include "PIC16BIT\PIC16BIT_CAL_UART.c"
  #endif
  #ifdef FC_CAL_AVR
	#include "AVR\AVR_CAL_UART.c"
  #endif
  #ifdef FC_CAL_ARM
	#include "ARM\ARM_CAL_UART.c"
  #endif
  #undef MX_UART_NUM
#endif
#ifdef CALFUNCTION
	#undef CALFUNCTION
#endif

